import { FormBaseOptions, FormGroupOptions, FormInputBuildOptions, FormSelectBuildOptions, FormSubmitOptions, FormTextareaBuildOptions, ItemActionToggleOptions, ListActionRefreshBuildOptions, ListBaseOptions, ListBuildOptions, ListHeaderBuildOptions, ListItemBuildOptions, ListItemsBuildOptions, ListNoMoreBuildOptions, ListPaginationBuildOptions, ListSearchBuildOptions, ListTitleBuildOptions, PaginationOptions } from '../components';
import { FormInputCheckboxBuildOptions } from '../components/form-input-checkbox/type';
import { Component } from './constants';
export declare type OptionPresetValueContext<V> = {
    enabled?: boolean;
    value?: V;
};
export declare type OptionPresetsValueContext<V> = {
    [key: string]: OptionPresetValueContext<V>;
};
export declare type OptionValueBuildContext<C extends Component | `${Component}`, K extends keyof ComponentOptions<C>> = {
    component: C;
    key: K;
    alt?: ComponentOptions<C>[K];
    value?: ComponentOptions<C>[K];
    preset?: OptionPresetsValueContext<ComponentOptions<C>[K]>;
};
export declare type ComponentFormOptions<C extends Component | `${Component}`> = C extends Component.FormBase | `${Component.FormBase}` ? FormBaseOptions : C extends Component.FormGroup | `${Component.FormGroup}` ? FormGroupOptions : C extends Component.FormInput | Component.FormInputText | `${Component.FormInput}` | `${Component.FormInputText}` ? FormInputBuildOptions : C extends Component.FormInputCheckbox | `${Component.FormInputCheckbox}` ? FormInputCheckboxBuildOptions : C extends Component.FormSelect | `${Component.FormSelect}` ? FormSelectBuildOptions : C extends Component.FormSubmit | `${Component.FormSubmit}` ? FormSubmitOptions : C extends Component.FormTextarea | `${Component.FormTextarea}` ? FormTextareaBuildOptions : {};
export declare type ComponentItemOptions<C extends Component | `${Component}`> = C extends Component.ItemActionToggle | `${Component.ItemActionToggle}` ? ItemActionToggleOptions<any> : {};
export declare type ComponentSpecialOptions<C extends Component | `${Component}`> = C extends Component.Pagination | `${Component.Pagination}` ? PaginationOptions : {};
export declare type ComponentListOptions<C extends Component | `${Component}`> = C extends Component.ListBase | `${Component.ListBase}` ? ListBaseOptions : C extends Component.List | `${Component.List}` ? ListBuildOptions<any> : C extends Component.ListActionRefresh | `${Component.ListActionRefresh}` ? ListActionRefreshBuildOptions : C extends Component.ListHeader | `${Component.ListHeader}` ? ListHeaderBuildOptions : C extends Component.ListItems | `${Component.ListItems}` ? ListItemsBuildOptions<any> : C extends Component.ListItem | `${Component.ListItem}` ? ListItemBuildOptions<any> : C extends Component.ListNoMore | `${Component.ListNoMore}` ? ListNoMoreBuildOptions<any> : C extends Component.ListPagination | `${Component.ListPagination}` ? ListPaginationBuildOptions<any> : C extends Component.ListSearch | `${Component.ListSearch}` ? ListSearchBuildOptions : C extends Component.ListTitle | `${Component.ListTitle}` ? ListTitleBuildOptions : {};
export declare type ComponentOptions<C extends Component | `${Component}`> = ComponentFormOptions<C> & ComponentItemOptions<C> & ComponentListOptions<C> & ComponentSpecialOptions<C>;
//# sourceMappingURL=type.d.ts.map